## gecode 6.0.0

=== CMakeLists.txt ===
#
#  Main authors:
#     Victor Zverovich <victor.zverovich@gmail.com>
#
#  Copyright:
#     Victor Zverovich, 2013
#
#  Last modified:
#     $Date$ by $Author$
#     $Revision$
#
#  This file is part of Gecode, the generic constraint
#  development environment:
#     http://www.gecode.org
#
#  Permission is hereby granted, free of charge, to any person obtaining
#  a copy of this software and associated documentation files (the
#  "Software"), to deal in the Software without restriction, including
#  without limitation the rights to use, copy, modify, merge, publish,
#  distribute, sublicense, and/or sell copies of the Software, and to
#  permit persons to whom the Software is furnished to do so, subject to
#  the following conditions:
#
#  The above copyright notice and this permission notice shall be
#  included in all copies or substantial portions of the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
#  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
#  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
#  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

#
# CMake build script for Gecode.
#

cmake_minimum_required(VERSION 2.8.8)

project(GECODE)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)

include(CheckCXXCompilerFlag)
if (GECODE_DISABLE_WARNINGS)
  if (MSVC)
    add_definitions(/wd4244 /wd4267 /wd4345 /wd4355 /wd4800)
  else ()
    foreach (flag -Wextra -Wall -pedantic)
      string(REPLACE ${flag} "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    endforeach ()
    if (CMAKE_COMPILER_IS_GNUCXX)
      add_definitions(-Wno-overloaded-virtual)
    elseif (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      add_definitions(-Wno-constant-logical-operand -Wno-switch)
    endif ()
  endif ()
endif ()

# The following part of config.h is hard to derive from configure.ac.
file(READ gecode/support/config.hpp.in CONFIG)
string(REGEX REPLACE "^/\\*([^*]|\\*[^/])*\\*/" "" CONFIG ${CONFIG})
string(REGEX MATCHALL "[^\n]*\n" CONFIG
"${CONFIG}
/* Define to 1 if you have the `getpagesize' function. */
#undef HAVE_GETPAGESIZE

/* Define to 1 if you have the <inttypes.h> header file. */
#undef HAVE_INTTYPES_H

/* Define to 1 if you have the <memory.h> header file. */
#undef HAVE_MEMORY_H

/* Define to 1 if you have a working `mmap' system call. */
#undef HAVE_MMAP

/* Define to 1 if you have the <stdint.h> header file. */
#undef HAVE_STDINT_H

/* Define to 1 if you have the <stdlib.h> header file. */
#undef HAVE_STDLIB_H

/* Define to 1 if you have the <strings.h> header file. */
#undef HAVE_STRINGS_H

/* Define to 1 if you have the <string.h> header file. */
#undef HAVE_STRING_H

/* Define to 1 if you have the <sys/param.h> header file. */
#undef HAVE_SYS_PARAM_H

/* Define to 1 if you have the <sys/stat.h> header file. */
#undef HAVE_SYS_STAT_H

/* Define to 1 if you have the <sys/types.h> header file. */
#undef HAVE_SYS_TYPES_H

/* Define to 1 if you have the <unistd.h> header file. */
#undef HAVE_UNISTD_H

/* Define to the address where bug reports for this package should be sent. */
#undef PACKAGE_BUGREPORT

/* Define to the full name of this package. */
#undef PACKAGE_NAME

/* Define to the full name and version of this package. */
#undef PACKAGE_STRING

/* Define to the one symbol short name of this package. */
#undef PACKAGE_TARNAME

/* Define to the home page for this package. */
#undef PACKAGE_URL

/* Define to the version of this package. */
#undef PACKAGE_VERSION

/* The size of `int', as computed by sizeof. */
#undef SIZEOF_INT

/* Define to 1 if you have the ANSI C header files. */
#undef STDC_HEADERS
")

# Get version numbers and parts of config.h from configure.ac.
file(READ configure.ac LINES)
# Replace semicolons with "<semi>" to avoid CMake messing with them.
string(REPLACE ";" "<semi>" LINES "${LINES}")
# Split into lines keeping newlines to avoid foreach skipping empty ones.
string(REGEX MATCHALL "[^\n]*\n" LINES "${LINES}")
set(ah_command FALSE)
foreach (line "${EXTRA_CONFIG}" ${LINES})
  string(REPLACE ";" "" line "${line}")
  if (ah_command)
    # Do nothing.
  elseif (line MATCHES "AC_INIT\\(([^,]*), *([^,]*), *([^)]*)\\)")
    set(PACKAGE ${CMAKE_MATCH_1})
    set(VERSION ${CMAKE_MATCH_2})
    set(PACKAGE_BUGREPORT ${CMAKE_MATCH_3})
    message(STATUS "Got VERSION=${VERSION} from configure.ac")
  elseif (line MATCHES "ac_gecode_flatzincversion=(.*)\n")
    set(GECODE_FLATZINC_VERSION "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_BOTTOM\\(\\[(.*)")
    set(ah_command bottom)
    set(line "${CMAKE_MATCH_1}")
  elseif (line MATCHES "AH_VERBATIM[^,]+,(.*)")
    set(ah_command verbatim)
    set(line "${CMAKE_MATCH_1}")
  endif ()
  if (ah_command)
    set(saved_ah_command ${ah_command})
    if (line MATCHES "^\\[(.*)")
      set(line "${CMAKE_MATCH_1}")
    endif ()
    if (line MATCHES "\\]\\)")
      set(ah_command FALSE)
      string(REPLACE "])" "" line "${line}")
    endif ()
    # For some reason CMake may bundle several lines together. Split them too.
    string(REGEX MATCHALL "[^\n]*\n" sublines "${line}")
    set(config_add "")
    foreach (subline ${sublines})
      set(config_add ${config_add} "${subline}")
    endforeach ()
    if (saved_ah_command STREQUAL "verbatim")
      set(CONFIG ${config_add} ${CONFIG})
    else ()
      set(CONFIG ${CONFIG} "\n" ${config_add})
    endif ()
  endif ()
endforeach ()
set(PACKAGE_NAME ${PACKAGE})
string(TOLOWER ${PACKAGE} PACKAGE_TARNAME)
set(PACKAGE_URL "")
set(PACKAGE_VERSION ${VERSION})
set(${PACKAGE}_VERSION ${VERSION})
string(REPLACE "." "-" GECODE_LIBRARY_VERSION "${VERSION}")
set(PACKAGE_STRING "${PACKAGE} ${VERSION}")
if (VERSION MATCHES "(.*)\\.(.*)\\.(.*)")
  math(EXPR GECODE_VERSION_NUMBER
    "${CMAKE_MATCH_1} * 100000 + ${CMAKE_MATCH_2} * 100 + ${CMAKE_MATCH_3}")
endif ()

set(GECODE_DLL_USERPREFIX "")
set(GECODE_DLL_USERSUFFIX "")
set(GECODE_HAS_INT_VARS "/**/")
set(GECODE_HAS_SET_VARS "/**/")
set(GECODE_HAS_FLOAT_VARS "/**/")
set(GECODE_STATIC_LIBS 1)
set(GECODE_ALLOCATOR "/**/")

check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
if (HAVE_VISIBILITY_HIDDEN_FLAG)
  set(GECODE_GCC_HAS_CLASS_VISIBILITY "/**/")
endif ()

if (WIN32)
  set(GECODE_THREADS_WINDOWS 1)
else ()
  set(GECODE_THREADS_PTHREADS 1)
endif ()

# Don't use Qt if GECODE_USE_QT is set to FALSE.
if (NOT DEFINED GECODE_USE_QT OR GECODE_USE_QT)
  find_package(Qt5 QUIET COMPONENTS Core Gui Widgets PrintSupport)
  if (Qt5_FOUND)
     set(GECODE_HAS_QT "/**/")
     set(GECODE_HAS_GIST "/**/")
     set(EXTRA_LIBS gist)
     set(CMAKE_AUTOMOC TRUE)
  else()
    find_package(Qt4)
    if (QT4_FOUND)
      set(GECODE_HAS_QT "/**/")
      set(GECODE_HAS_GIST "/**/")
      set(EXTRA_LIBS gist)
      set(CMAKE_AUTOMOC TRUE)
      include(${QT_USE_FILE})
    endif()
  endif()
endif ()

include(CheckSymbolExists)
check_symbol_exists(getpagesize unistd.h HAVE_GETPAGESIZE)
check_symbol_exists(mmap sys/mman.h HAVE_MMAP)

# Checks for header files.
include(CheckIncludeFiles)
foreach (header inttypes.h memory.h stdint.h stdlib.h strings.h string.h
                sys/param.h sys/stat.h sys/time.h sys/types.h unistd.h)
  string(TOUPPER HAVE_${header} var)
  string(REGEX REPLACE "\\.|/" "_" var ${var})
  check_include_files(${header} ${var})
endforeach ()
check_include_files(stdio.h STDC_HEADERS)
if (HAVE_SYS_TIME_H)
  set(GECODE_USE_GETTIMEOFDAY 1)
else ()
  set(GECODE_USE_CLOCK 1)
endif ()
if (HAVE_UNISTD_H)
  set(GECODE_HAS_UNISTD_H 1)
endif ()

include(CheckCXXSourceCompiles)
check_cxx_source_compiles("
   #include <ext/hash_map>
   int main() {}" HAVE_EXT_HASH_MAP)
if (HAVE_EXT_HASH_MAP)
  set(GECODE_HAS_GNU_HASH_MAP "/**/")
endif ()

include(CheckTypeSize)
check_type_size(int SIZEOF_INT)

# Check for inline.
include(CheckCSourceCompiles)
check_c_source_compiles("
  inline __attribute__ ((__always_inline__)) void foo(void) {}
  int main() {}" HAVE_ALWAYS_INLINE)
set(forceinline inline)
if (HAVE_ALWAYS_INLINE)
  set(forceinline "inline __attribute__ ((__always_inline__))")
endif ()

check_c_source_compiles("
  int main() { return __builtin_ffsl(0); }" HAVE_BUILTIN_FFSL)
if (HAVE_BUILTIN_FFSL)
  set(GECODE_HAS_BUILTIN_FFSL "/**/")
endif ()

# Process config.hpp using autoconf rules.
list(LENGTH CONFIG length)
math(EXPR length "${length} - 1")
foreach (i RANGE ${length})
  list(GET CONFIG ${i} line)
  if (line MATCHES "^#( *)undef (.*)\n")
    set(space "${CMAKE_MATCH_1}")
    set(var ${CMAKE_MATCH_2})
    if (NOT DEFINED ${var} OR (var MATCHES "HAVE_.*" AND NOT ${var}))
      set(line "/* #${space}undef ${var} */\n")
    else ()
      if ("${${var}}" STREQUAL "/**/" OR "${var}" STREQUAL "GECODE_VERSION_NUMBER" OR
          "${var}" STREQUAL "forceinline" OR var MATCHES "SIZEOF_.*")
        set(value ${${var}})
      elseif (NOT (var MATCHES ^HAVE OR ${var} EQUAL 0 OR ${var} EQUAL 1))
        set(value \"${${var}}\")
      elseif (${var})
        set(value 1)
      else ()
        set(value 0)
      endif ()
      set(line "#${space}define ${var} ${value}\n")
    endif ()
  endif ()
  string(REPLACE "<semi>" ";" line "${line}")
  set(CONFIG_OUT "${CONFIG_OUT}${line}")
endforeach ()
file(WRITE ${GECODE_BINARY_DIR}/gecode/support/config.hpp
"/* gecode/support/config.hpp.  Generated from config.hpp.in by configure.  */
/* gecode/support/config.hpp.in.  Generated from configure.ac by autoheader.  */

/* Disable autolink because all the dependencies are handled by CMake. */
#define GECODE_BUILD_SUPPORT
#define GECODE_BUILD_KERNEL
#define GECODE_BUILD_SEARCH
#define GECODE_BUILD_INT
#define GECODE_BUILD_SET
#define GECODE_BUILD_FLOAT
#define GECODE_BUILD_MINIMODEL
#define GECODE_BUILD_FLATZINC
#define GECODE_BUILD_DRIVER
#define GECODE_BUILD_GIST

${CONFIG_OUT}")

# Expands a value substituting variables and appends the result to ${var}.
function (expand var value)
  if (value MATCHES "\\$\\(([^:]+)(.*)\\)")
    # Perform substitution.
    set(pattern ${CMAKE_MATCH_2})
    set(items ${${CMAKE_MATCH_1}})
    if (pattern MATCHES ":%=([^%]*)%([^%]*)")
      set(values )
      foreach (item ${items})
        set(values ${values} ${CMAKE_MATCH_1}${item}${CMAKE_MATCH_2})
      endforeach ()
    else ()
      set(values ${items})
    endif ()
  else ()
    set(values ${value})
  endif ()
  set(${var} ${${var}} ${values} PARENT_SCOPE)
endfunction ()

# Parse Makefile.in extracting variables.
file(READ Makefile.in text)
string(REPLACE "\\\n" "" text "${text}")
string(REGEX REPLACE "#[^\n]*\n" "" text "${text}")
string(REGEX MATCHALL "[^\n]+" lines "${text}")
foreach (line ${lines})
  if (line MATCHES "([^ \t]+)[ \t]*=[ \t]*(.*)")
    set(var ${CMAKE_MATCH_1})
    set(${var} )
    string(REGEX MATCHALL "[^ \t]+" items "${CMAKE_MATCH_2}")
    foreach (item ${items})
      expand(${var} ${item})
    endforeach ()
  endif ()
endforeach ()

foreach (lib support kernel search int set float
             minimodel driver flatzinc ${EXTRA_LIBS})
  if (lib STREQUAL "minimodel")
    set(libupper MM)
  else ()
    string(TOUPPER ${lib} libupper)
  endif ()
  if (${libupper}SRC)
    set(sources )
    foreach (src ${${libupper}SRC} ${${libupper}_GENSRC})
      if ((src STREQUAL "gecode/support/thread/pthreads.cpp" AND MSVC) OR
           src STREQUAL "gecode/float/rounding.cpp")
        # ignore empty source files to prevent linker warnings
      else ()
        set(sources ${sources} ${src})
      endif ()
    endforeach ()
    add_library(gecode${lib} ${sources} ${${libupper}HDR})
    target_include_directories(gecode${lib}
      PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
  endif ()
endforeach ()

find_package(Threads)
target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
target_link_libraries(gecodekernel gecodesupport)

=== examples/CMakeLists.txt ===
#
#  Main authors:
#     Petter Strandmark <petter.strandmark@gmail.com>
#
#  Copyright:
#     Petter Strandmark, 2014
#
#  Last modified:
#     $Date$ by $Author$
#     $Revision$
#
#  This file is part of Gecode, the generic constraint
#  development environment:
#     http://www.gecode.org
#
#  Permission is hereby granted, free of charge, to any person obtaining
#  a copy of this software and associated documentation files (the
#  "Software"), to deal in the Software without restriction, including
#  without limitation the rights to use, copy, modify, merge, publish,
#  distribute, sublicense, and/or sell copies of the Software, and to
#  permit persons to whom the Software is furnished to do so, subject to
#  the following conditions:
#
#  The above copyright notice and this permission notice shall be
#  included in all copies or substantial portions of the Software.
#
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
#  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
#  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
#  NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
#  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
#  OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
#  WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

#
# CMake build script for Gecode examples.
#

if (MSVC)
	# Needed for some examples to prevent
	# C1128: number of sections exceeded object file format limit : compile with /bigobj
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /bigobj")
endif()

macro (GECODE_EXAMPLE NAME)
	add_executable(${NAME}${EXECUTABLE_EXTENSION}
	               ${NAME}.cpp)
	target_link_libraries(${NAME}${EXECUTABLE_EXTENSION} gecodeminimodel gecodedriver)
	set_property(TARGET ${NAME}${EXECUTABLE_EXTENSION}         PROPERTY FOLDER "Examples")
endmacro ()

file(GLOB EXAMPLE_FILES *.cpp)
foreach (EXAMPLE_FILE ${EXAMPLE_FILES})
	get_filename_component(EXAMPLE_NAME ${EXAMPLE_FILE} NAME_WE)
	message("-- Adding example: " ${EXAMPLE_NAME})
	gecode_example(${EXAMPLE_NAME})
endforeach()

=== debian/changelog ===
gecode (6.0.0-2) unstable; urgency=medium

  * Fix FTBFS on 32 bit arches by renaming an overloaded function that
    clashed on them.

 -- Kari Pahula <kaol@debian.org>  Thu, 05 Apr 2018 22:44:19 +0300

gecode (6.0.0-1) unstable; urgency=medium

  * New upstream release (soname 46)
  * Standards-Versions 4.1.3 (no changes necessary).
  * Pass --enable-cppprofiler to configure flags.
  * Convert upstream changelog to UTF-8 encoding.

 -- Kari Pahula <kaol@debian.org>  Mon, 02 Apr 2018 02:14:53 +0300

=== debian/control ===
Source: gecode
Priority: optional
Maintainer: Kari Pahula <kaol@debian.org>
Build-Depends: debhelper (>= 9), autotools-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev, flex, bison, qtbase5-dev, libboost-dev
Build-Depends-Indep: graphviz, doxygen
Build-Conflicts: libqt4-dev
Standards-Version: 4.1.3
Section: libs
Homepage: http://www.gecode.org/

Package: libgecode-dev
Section: libdevel
Architecture: any
Depends: libgecode46 (= ${binary:Version}), libgecodegist46 (= ${binary:Version}), libgecodeflatzinc46 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
Suggests: libgecode-doc
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

Package: libgecode-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.
 .
 This package has the API documentation and examples.

Package: libgecode46
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Description: generic constraint development environment
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 Gecode is radically open for programming: it can be easily
 interfaced to other systems. It supports the programming of new
 propagators (as implementation of constraints), branching strategies,
 and search engines. New variable domains can be programmed at the same
 level of efficiency as finite domain and integer set variables that
 come predefined with Gecode.

Package: libgecodegist46
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Description: Gecode Interactive Search Tool library
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 This package contains libgecodegist, a graphical debugging tool, and
 libgecodedriver, a set of helper classes for writing standalone
 programs.  They have been separated from the main Gecode library
 package to avoid pulling in Qt as a dependency.

Package: libgecodeflatzinc46
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Suggests: libgecode-dev
Homepage: http://www.gecode.org/flatzinc.html
Description: Gecode support for FlatZinc modelling language
 Gecode is a toolkit for developing constraint-based systems and
 applications. Gecode provides a constraint solver with
 state-of-the-art performance while being modular and extensible.
 .
 FlatZinc is a low-level modelling language for constraint
 problems. It is designed to be easily interfaceable to constraint
 solvers (like Gecode). For more information on FlatZinc, please refer
 to the MiniZinc pages of the G12 project
 <http://www.g12.cs.mu.oz.au/minizinc/>.

Package: flatzinc
Section: devel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: minizinc
Replaces: libgecode-dev (<< 3.7.0)
Homepage: http://www.gecode.org/flatzinc.html
Description: constraint problem modelling language
 FlatZinc is a low-level modelling language for constraint
 problems. It is designed to be easily interfaceable to constraint
 solvers (like Gecode). For more information on FlatZinc, please refer
 to the MiniZinc pages of the G12 project
 <http://www.g12.cs.mu.oz.au/minizinc/>.
 .
 We provide a parser that reads a FlatZinc model from a file, and
 returns a Gecode Space object that represents the model. We also
 provide a simple front-end, an executable program that reads a
 FlatZinc model and prints the solution (if any) on the standard
 output.
 .
 The FlatZinc interpreter that ships with Gecode version 4.4.0
 supports the FlatZinc language and MiniZinc global constraint
 definitions of MiniZinc version 1.6.0.

=== debian/rules ===
#!/usr/bin/make -f

DEB_CONFIGURE_EXTRA_FLAGS=--enable-gist --enable-qt --enable-float-vars --enable-cppprofiler --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) QT_SELECT=5 --with-host-os=linux
DEB_BUILD_PARALLEL=yes
DEB_MAKE_CHECK_TARGET=check LD_LIBRARY_PATH=.
DEB_DH_BUILDDEB_ARGS=-- -Zxz
DEB_MAKE_ENVVARS=QT_SELECT=5

include /usr/share/cdbs/1/class/autotools.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/rules/autoreconf.mk

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS))$(filter ia64 mipsel,$(DEB_HOST_ARCH)))
	CFLAGS += -O3
	CXXFLAGS += -O3
endif

CFLAGS += -D_REENTRANT $(CPPFLAGS)
CXXFLAGS += -D_REENTRANT $(CPPFLAGS)
DEB_CONFIGURE_EXTRA_FLAGS += DLLFLAGS="$(LDFLAGS)" GLDFLAGS="$(LDFLAGS)"

changelog:
	$(MAKE) ChangeLog
	iconv -f ISO-8859-1 -t UTF-8 ChangeLog > changelog
	rm ChangeLog

common-install-prehook-impl:: changelog

build/libgecode-doc::
	$(MAKE) doc

binary-fixup/libgecode-doc::
	find $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/ -type f -exec chmod 0644 '{}' ';'
	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/examples/Makefile
	rm -f $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-doc/html/jquery.js

binary-fixup/libgecode-dev::
	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;
	rm -f $(CURDIR)/debian/libgecode-dev/usr/include/gecode/third-party/boost/LICENSE_1_0.txt

common-binary-fixup-arch::
	for libso in `find debian/ -type f -regex 'debian/lib.*/lib.*\.so\.[0-9]+\.[0-9]+'`; do ln -s $${libso##*/} $${libso%.*}; done

binary/libgecode-doc::
	[ -e debian/libgecode-doc/usr/share/doc/libgecode-doc/html/ ]

## gecode 6.0.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,6 @@
 #
 #  Copyright:
 #     Victor Zverovich, 2013
-#
-#  Last modified:
-#     $Date$ by $Author$
-#     $Revision$
 #
 #  This file is part of Gecode, the generic constraint
 #  development environment:
@@ -379,3 +375,4 @@
 find_package(Threads)
 target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
 target_link_libraries(gecodekernel gecodesupport)
+target_link_libraries(gecodesearch gecodekernel)

=== debian/changelog ===
gecode (6.0.1-1) unstable; urgency=medium

  * New upstream release (soname 47)
  * Pass --enable-cbs to configure flags.
  * Remove previous 32 bit patch in favor of upstream's own fix.

 -- Kari Pahula <kaol@debian.org>  Sat, 02 Jun 2018 10:17:44 +0300

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode46 (= ${binary:Version}), libgecodegist46 (= ${binary:Version}), libgecodeflatzinc46 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
+Depends: libgecode47 (= ${binary:Version}), libgecodegist47 (= ${binary:Version}), libgecodeflatzinc47 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode46
+Package: libgecode47
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -62,7 +62,7 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist46
+Package: libgecodegist47
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -78,7 +78,7 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc46
+Package: libgecodeflatzinc47
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

## gecode 6.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,6 +54,21 @@
     endif ()
   endif ()
 endif ()
+
+if ( (CMAKE_VERSION VERSION_GREATER 3.1.0) OR (CMAKE_VERSION VERSION_EQUAL 3.1.0) )
+  set (CMAKE_CXX_STANDARD 11)
+endif()
+check_cxx_compiler_flag(-std=c++11 HAS_STDCPP11)
+if (HAS_STDCPP11)
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")
+else()
+  check_cxx_compiler_flag(-std=c++0x HAS_STDCPP0X)
+  if (HAS_STDCPP0X)
+    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
+  else()
+    message("Warning: Initial check for C++11 unsuccessful. This is fine if HAS_CPP11 test below succeeds.")
+  endif()
+endif()
 
 # The following part of config.h is hard to derive from configure.ac.
 file(READ gecode/support/config.hpp.in CONFIG)
@@ -199,6 +214,13 @@
   set(GECODE_THREADS_PTHREADS 1)
 endif ()
 
+option(ENABLE_GIST "Enable gist" OFF)
+if (ENABLE_GIST)
+  set(GECODE_USE_QT TRUE)
+else()
+  set(GECODE_USE_QT FALSE)
+endif()
+
 # Don't use Qt if GECODE_USE_QT is set to FALSE.
 if (NOT DEFINED GECODE_USE_QT OR GECODE_USE_QT)
   find_package(Qt5 QUIET COMPONENTS Core Gui Widgets PrintSupport)
@@ -257,11 +279,18 @@
 check_c_source_compiles("
   inline __attribute__ ((__always_inline__)) void foo(void) {}
   int main() {}" HAVE_ALWAYS_INLINE)
+check_c_source_compiles("
+  __forceinline void foo(void) {}
+  int main() {}" HAVE_FORCE_INLINE)
 set(forceinline inline)
 if (HAVE_ALWAYS_INLINE)
   set(forceinline "inline __attribute__ ((__always_inline__))")
 endif ()
-
+if (HAVE_FORCE_INLINE)
+  set(forceinline "__forceinline")
+endif ()
+
+# Check for bit index
 check_c_source_compiles("
   int main() { return __builtin_ffsl(0); }" HAVE_BUILTIN_FFSL)
 if (HAVE_BUILTIN_FFSL)
@@ -354,25 +383,3 @@
   if (lib STREQUAL "minimodel")
     set(libupper MM)
   else ()
-    string(TOUPPER ${lib} libupper)
-  endif ()
-  if (${libupper}SRC)
-    set(sources )
-    foreach (src ${${libupper}SRC} ${${libupper}_GENSRC})
-      if ((src STREQUAL "gecode/support/thread/pthreads.cpp" AND MSVC) OR
-           src STREQUAL "gecode/float/rounding.cpp")
-        # ignore empty source files to prevent linker warnings
-      else ()
-        set(sources ${sources} ${src})
-      endif ()
-    endforeach ()
-    add_library(gecode${lib} ${sources} ${${libupper}HDR})
-    target_include_directories(gecode${lib}
-      PUBLIC ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
-  endif ()
-endforeach ()
-
-find_package(Threads)
-target_link_libraries(gecodesupport ${CMAKE_THREAD_LIBS_INIT})
-target_link_libraries(gecodekernel gecodesupport)
-target_link_libraries(gecodesearch gecodekernel)

=== debian/changelog ===
gecode (6.1.0-2) unstable; urgency=medium

  * Backport upstream patch to skip failing tests. (Closes: #912969)

 -- Kari Pahula <kaol@debian.org>  Sat, 12 Jan 2019 22:58:51 +0200

gecode (6.1.0-1) unstable; urgency=medium

  * New upstream release (soname 48)

 -- Kari Pahula <kaol@debian.org>  Sat, 12 Jan 2019 22:48:37 +0200

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode47 (= ${binary:Version}), libgecodegist47 (= ${binary:Version}), libgecodeflatzinc47 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
+Depends: libgecode48 (= ${binary:Version}), libgecodegist48 (= ${binary:Version}), libgecodeflatzinc48 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -44,7 +44,7 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode47
+Package: libgecode48
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -62,7 +62,7 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist47
+Package: libgecodegist48
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -78,7 +78,7 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc47
+Package: libgecodeflatzinc48
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}

## gecode 6.2.0

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -4,10 +4,6 @@
 #
 #  Copyright:
 #     Petter Strandmark, 2014
-#
-#  Last modified:
-#     $Date$ by $Author$
-#     $Revision$
 #
 #  This file is part of Gecode, the generic constraint
 #  development environment:

=== contribs/quacode/CMakeLists.txt ===
#
# Main authors:
#    Vincent Barichard <Vincent.Barichard@univ-angers.fr>
#
# Copyright:
#    Vincent Barichard, 2013
#
# Last modified:
#    $Date$ by $Author$
#    $Revision$
#
# This file is part of Quacode:
#    http://quacode.barichard.com
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
#

CMAKE_MINIMUM_REQUIRED(VERSION 2.8)

SET(GECODE_SRC "${CMAKE_SOURCE_DIR}/../.." CACHE PATH "Path where GeCode source is installed")
SET(GECODE_BIN "${GECODE_SRC}" CACHE PATH "Path where GeCode libs and binaries are installed")
SET(BUILD_EXAMPLES ON CACHE BOOL "Build examples or not")

# If the user specifies -DCMAKE_BUILD_TYPE on the command line, take their definition
# and dump it in the cache along with proper documentation, otherwise set CMAKE_BUILD_TYPE
# to Debug prior to calling PROJECT()
#
IF(NOT DEFINED CMAKE_BUILD_TYPE)
  # Check if Gecode is configured with --enable-debug
  FILE(STRINGS ${GECODE_BIN}/config.status GECODE_DEBUG_BUILD REGEX "S\\[\"DEBUG_BUILD\"\\]=")
  IF(GECODE_DEBUG_BUILD MATCHES "yes")
    SET(QUACODE_BUILD_TYPE "Debug")
  ELSE()
    SET(QUACODE_BUILD_TYPE "Release")
  ENDIF()

   SET(CMAKE_BUILD_TYPE "${QUACODE_BUILD_TYPE}" CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel.")
ENDIF()

PROJECT(Quacode)
SET(CMAKE_CXX_FLAGS "-std=c++11")

SET(CMAKE_VERBOSE_MAKEFILE TRUE)

# Check if Gecode is configured with --enable-audit
FILE(STRINGS ${GECODE_BIN}/config.status GECODE_AUDIT REGEX "D\\[\"GECODE_AUDIT\"\\]=")
IF(GECODE_AUDIT)
  SET(QUACODE_AUDIT TRUE)
ELSE()
  SET(QUACODE_AUDIT FALSE)
ENDIF()
SET(LOG_AUDIT ${QUACODE_AUDIT} CACHE BOOL "Set to true to generate log output.")

IF(UNIX)
  # determine, whether we want a static binary
  SET(STATIC_LINKING FALSE CACHE BOOL "Build a static binary?")
  # do we want static libraries?
  IF(STATIC_LINKING)
    SET(BUILD_SHARED_LIBS OFF)
    # To know in source file that we compil static
    ADD_DEFINITIONS(-DQUACODE_STATIC_LIBS)
    # When STATIC_LINKING is TRUE, than cmake looks for libraries ending
    # with .a. This is for linux only!
    SET(CMAKE_FIND_LIBRARY_SUFFIXES ".a")
    SET(CMAKE_EXE_LINKER_FLAGS "-static")
    # Remove flags to get rid off all the -Wl,Bydnamic
    SET(CMAKE_EXE_LINK_DYNAMIC_C_FLAGS)
    SET(CMAKE_EXE_LINK_DYNAMIC_CXX_FLAGS)
    # Use static libs for Boost
    SET(Boost_USE_STATIC_LIBS ON)
    SET(Boost_USE_STATIC_RUNTIME ON)
  ELSE(STATIC_LINKING)
    SET(BUILD_SHARED_LIBS ON)
  ENDIF(STATIC_LINKING)
ELSE(UNIX)
  SET(BUILD_SHARED_LIBS ON)
ENDIF(UNIX)

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_MODULE_PATH})
FIND_PACKAGE(Gecode)

IF(NOT GECODE_FOUND)
  MESSAGE(FATAL_ERROR "Gecode is needed, consider to install it")
ELSE (NOT GECODE_FOUND)
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  INCLUDE_DIRECTORIES(${GECODE_BIN})
  INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR})
  INCLUDE_DIRECTORIES(${GECODE_SRC})

  LINK_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
  LINK_DIRECTORIES(${GECODE_BIN})

  IF (CMAKE_COMPILER_IS_GNUCXX)
    ADD_DEFINITIONS(-Wall)
    ADD_DEFINITIONS(-Wextra)
    ADD_DEFINITIONS(-Wno-unused-local-typedefs)
    ADD_DEFINITIONS(-fimplement-inlines)
    ADD_DEFINITIONS(-fno-inline-functions)
    ADD_DEFINITIONS(-pipe)
    ADD_DEFINITIONS(-fPIC)
    SET(CMAKE_CXX_FLAGS_DEBUG "-ggdb")
  ENDIF ()

  IF (LOG_AUDIT)
    ADD_DEFINITIONS(-DLOG_AUDIT)
  ENDIF()

  INCLUDE(CheckCXXCompilerFlag)
  check_cxx_compiler_flag(-fvisibility=hidden HAVE_VISIBILITY_HIDDEN_FLAG)
  IF (HAVE_VISIBILITY_HIDDEN_FLAG)
    ADD_DEFINITIONS(-fvisibility=hidden)
    ADD_DEFINITIONS(-DQUACODE_GCC_HAS_CLASS_VISIBILITY)
  ENDIF()

  FIND_PACKAGE(Threads)

  SET(QUACODE_HEADERS
    quacode/qcsp.hh
    quacode/qspaceinfo.hh
    quacode/support/dynamic-list.hh
    quacode/support/log.hh
    quacode/search/sequential/qpath.hh
    quacode/search/sequential/qdfs.hh
    quacode/qint/qbool.hh
  )
  SET(QUACODE_HPP
    quacode/qspaceinfo.hpp
    quacode/search/qdfs.hpp
    quacode/qint/watch.hpp
    quacode/qint/qbool/clause.hpp
    quacode/qint/qbool/eq.hpp
    quacode/qint/qbool/eqv.hpp
    quacode/qint/qbool/or.hpp
    quacode/qint/qbool/xor.hpp
    quacode/qint/qbool/xorv.hpp
  )
  SET(QUACODE_SRCS
    quacode/qspaceinfo.cpp
    quacode/support/log.cpp
    quacode/search/qdfs.cpp
    quacode/search/sequential/qpath.cpp
    quacode/qint/qbool/qbool.cpp
    ${GECODE_SRC}/gecode/search/meta/nogoods.cpp
  )
  SET(QUACODE_EXAMPLES_SRCS
    examples/qbf.cpp
    examples/qdimacs.cpp
    examples/nim-fibo.cpp
    examples/matrix-game.cpp
    examples/connect-four.cpp
    examples/baker.cpp
    examples/rndQCSP.cpp
  )

  SOURCE_GROUP("Hpp Files" REGULAR_EXPRESSION ".hpp")

  SET_SOURCE_FILES_PROPERTIES(${ALL_HEADERS} PROPERTIES HEADER_FILE_ONLY TRUE)
  SET_SOURCE_FILES_PROPERTIES(${ALL_HPP} PROPERTIES HEADER_FILE_ONLY TRUE)

  ADD_LIBRARY(quacode ${QUACODE_SRCS} ${QUACODE_HEADERS} ${QUACODE_HPP})
  TARGET_LINK_LIBRARIES(quacode ${GECODE_LIBRARIES})
  SET_TARGET_PROPERTIES(quacode PROPERTIES COMPILE_DEFINITIONS "BUILD_QUACODE_LIB")
  INSTALL(TARGETS quacode LIBRARY DESTINATION lib ARCHIVE DESTINATION lib/static)
  SET(QUACODE_LIBRARIES quacode)

  IF(BUILD_EXAMPLES)
    # Add targets for examples
    FOREACH (example ${QUACODE_EXAMPLES_SRCS})
      GET_FILENAME_COMPONENT(exampleBin ${example} NAME_WE)
      ADD_EXECUTABLE(${exampleBin} ${example})
      TARGET_LINK_LIBRARIES(${exampleBin} ${QUACODE_LIBRARIES} ${GECODE_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
      INSTALL(TARGETS ${exampleBin} RUNTIME DESTINATION bin)

      # set -static, when STATIC_LINKING is TRUE and set LINK_SEARCH_END_STATIC
      # to remove the additional -bdynamic from the linker line.
      IF(UNIX AND STATIC_LINKING)
          SET(CMAKE_EXE_LINKER_FLAGS "-static")
          SET_TARGET_PROPERTIES(${exampleBin} PROPERTIES LINK_SEARCH_END_STATIC 1)
      ENDIF(UNIX AND STATIC_LINKING)
    ENDFOREACH ()
  ENDIF(BUILD_EXAMPLES)

ENDIF(NOT GECODE_FOUND)

=== debian/changelog ===
gecode (6.2.0-7) unstable; urgency=medium

  * Use dh for debian/rules.
  * Move libgecode-doc examples and html under
    /usr/share/doc/libgecode-dev/ directory.
  * Fix doc-base to point to html files under libgecode-dev directory.
  * Fix changelog build (Closes: #1092413).
  * Move debian packaging to Salsa git.

 -- Kari Pahula <kaol@debian.org>  Tue, 11 Feb 2025 19:33:26 +0200

gecode (6.2.0-6) unstable; urgency=medium

  * Standards-Version 4.7.0 (no changes necessary)
  * Run autoupdate and rename AC_HELP_STRING to reduce warnings.
    (Closes: #978817)
  * Add gecode/flatzinc/parser.tab.hpp and configure.ac to debian/clean.
  * Copy parser.tab.hpp as parser.tab.hh during build.
  * Remove flatzinc package due to incompatibility with current MiniZinc
    versions.
  * Fix FTBFS with GCC 14. (Closes: #1074982)

 -- Kari Pahula <kaol@debian.org>  Tue, 27 Aug 2024 06:47:35 +0300

gecode (6.2.0-5.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062064

 -- Steve Langasek <vorlon@debian.org>  Wed, 28 Feb 2024 15:56:55 +0000

gecode (6.2.0-5) unstable; urgency=medium

  * Revert to dh compat 10 to cope with cdbs and dh_systemd_enable.
  * Drop obsolete build deps autotools-deb and dh-autoreconf.

 -- Kari Pahula <kaol@debian.org>  Sun, 09 Aug 2020 08:34:08 +0300

gecode (6.2.0-4) unstable; urgency=medium

  * Leave gecode/flatzinc/parser.tab.hpp name as is since the generated
    file gecode/flatzinc/parser.tab.cpp includes it. (Closes: #966903)
  * Standards-Version 4.5.0 and dh compat 13.

 -- Kari Pahula <kaol@debian.org>  Sat, 08 Aug 2020 19:03:19 +0300

gecode (6.2.0-3) unstable; urgency=medium

  * Upload to unstable

 -- Kari Pahula <kaol@debian.org>  Fri, 10 Jan 2020 13:38:25 +0200

gecode (6.2.0-2) experimental; urgency=medium

  * Add Breaks and Replaces on minizinc (<< 2.4.1) to properly move
    /usr/share/minizinc/gecode to flatzinc package (Closes: #947444)
  * Remove obsolete Breaks on libgecode-dev from flatzinc
  * Update link to https://minizinc.org/ in flatzinc description
  * Add shell script /usr/share/minizinc/fzn-gecode-gist and
    gecode-gist.msc for invoking fzn-gecode with -mode gist.

 -- Kari Pahula <kaol@debian.org>  Wed, 01 Jan 2020 12:37:59 +0200

gecode (6.2.0-1) experimental; urgency=medium

  * New upstream release (soname 49)
  * Standards-Version 4.4.1 (didn't switch debian/rules to dh yet)
  * Update examples' Makefile to have .o files before LDFLAGS to satisfy
    as-needed.
  * Remove shorter-make-check patch as it's part of upstream now.
  * Add gecode.msc file from upstream's binary release and mznlib contents
    to flatzinc package.

 -- Kari Pahula <kaol@debian.org>  Mon, 16 Dec 2019 20:31:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,19 @@
 Source: gecode
 Priority: optional
 Maintainer: Kari Pahula <kaol@debian.org>
-Build-Depends: debhelper (>= 9), autotools-dev, cdbs (>= 0.4.93~), dh-autoreconf, libmpfr-dev, flex, bison, qtbase5-dev, libboost-dev
+Build-Depends: debhelper, debhelper-compat (= 13), libmpfr-dev, flex, bison, qtbase5-dev, libboost-dev
 Build-Depends-Indep: graphviz, doxygen
 Build-Conflicts: libqt4-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.7.0
 Section: libs
-Homepage: http://www.gecode.org/
+Homepage: https://www.gecode.org/
+Vcs-Browser: https://salsa.debian.org/kaol/gecode
+Vcs-Git: https://salsa.debian.org/kaol/gecode.git
 
 Package: libgecode-dev
 Section: libdevel
 Architecture: any
-Depends: libgecode48 (= ${binary:Version}), libgecodegist48 (= ${binary:Version}), libgecodeflatzinc48 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
+Depends: libgecode49t64 (= ${binary:Version}), libgecodegist49t64 (= ${binary:Version}), libgecodeflatzinc49t64 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}, qtbase5-dev, libmpfr-dev, libboost-dev
 Suggests: libgecode-doc
 Description: generic constraint development environment
  Gecode is a toolkit for developing constraint-based systems and
@@ -44,7 +46,10 @@
  .
  This package has the API documentation and examples.
 
-Package: libgecode48
+Package: libgecode49t64
+Provides: ${t64:Provides}
+Replaces: libgecode49
+Breaks: libgecode49 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -62,7 +67,10 @@
  level of efficiency as finite domain and integer set variables that
  come predefined with Gecode.
 
-Package: libgecodegist48
+Package: libgecodegist49t64
+Provides: ${t64:Provides}
+Replaces: libgecodegist49
+Breaks: libgecodegist49 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -78,7 +86,10 @@
  programs.  They have been separated from the main Gecode library
  package to avoid pulling in Qt as a dependency.
 
-Package: libgecodeflatzinc48
+Package: libgecodeflatzinc49t64
+Provides: ${t64:Provides}
+Replaces: libgecodeflatzinc49
+Breaks: libgecodeflatzinc49 (<< ${source:Version})
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -93,29 +104,20 @@
  FlatZinc is a low-level modelling language for constraint
  problems. It is designed to be easily interfaceable to constraint
  solvers (like Gecode). For more information on FlatZinc, please refer
- to the MiniZinc pages of the G12 project
- <http://www.g12.cs.mu.oz.au/minizinc/>.
+ to the MiniZinc pages of the G12 project <https://minizinc.org/>.
 
-Package: flatzinc
-Section: devel
-Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends: minizinc
-Replaces: libgecode-dev (<< 3.7.0)
-Homepage: http://www.gecode.org/flatzinc.html
-Description: constraint problem modelling language
- FlatZinc is a low-level modelling language for constraint
- problems. It is designed to be easily interfaceable to constraint
- solvers (like Gecode). For more information on FlatZinc, please refer
- to the MiniZinc pages of the G12 project
- <http://www.g12.cs.mu.oz.au/minizinc/>.
- .
- We provide a parser that reads a FlatZinc model from a file, and
- returns a Gecode Space object that represents the model. We also
- provide a simple front-end, an executable program that reads a
- FlatZinc model and prints the solution (if any) on the standard
- output.
- .
- The FlatZinc interpreter that ships with Gecode version 4.4.0
- supports the FlatZinc language and MiniZinc global constraint
- definitions of MiniZinc version 1.6.0.
+#Package: flatzinc
+#Section: devel
+#Architecture: any
+#Depends: ${shlibs:Depends}, ${misc:Depends}
+#Recommends: minizinc
+#Homepage: http://www.gecode.org/flatzinc.html
+#Description: constraint problem modelling language
+# FlatZinc is a low-level modelling language for constraint
+# problems. It is designed to be easily interfaceable to constraint
+# solvers (like Gecode). For more information on FlatZinc, please refer
+# to the MiniZinc pages of the G12 project <https://www.minizinc.org/>.
+# .
+# The FlatZinc interpreter that ships with Gecode supports the FlatZinc
+# language and MiniZinc global constraint definitions of MiniZinc
+# version 1.6.0.

=== debian/rules ===
#!/usr/bin/make -f

DEB_MAKE_CHECK_TARGET=check LD_LIBRARY_PATH=.
DEB_DH_BUILDDEB_ARGS=-- -Zxz
DEB_MAKE_ENVVARS=QT_SELECT=5

ifeq (,$(findstring noopt,$(DEB_BUILD_OPTIONS))$(filter ia64 mipsel,$(DEB_HOST_ARCH)))
	CFLAGS += -O3
	CXXFLAGS += -O3
endif

CFLAGS += -D_REENTRANT $(CPPFLAGS)
CXXFLAGS += -D_REENTRANT $(CPPFLAGS)
DEB_CONFIGURE_EXTRA_FLAGS += DLLFLAGS="$(LDFLAGS)" GLDFLAGS="$(LDFLAGS)"

%: configure.ac
	dh $@ --with=autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --enable-gist --enable-qt --enable-float-vars --enable-cppprofiler --enable-cbs --disable-examples --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH) QT_SELECT=5 --with-host-os=linux

override_dh_auto_build-indep: changelog
	$(MAKE) doc

changelog:
	$(MAKE) ChangeLog
	iconv -f ISO-8859-1 -t UTF-8 ChangeLog > changelog
	rm ChangeLog

configure.ac:
	ln -s configure.ac.in configure.ac

override_dh_install-indep:
	dh_install
	find $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-dev/examples/ -type f -exec chmod 0644 '{}' ';'
	install -m 0644 -D debian/Makefile.examples $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-dev/examples/Makefile

override_dh_installdocs-indep:
	dh_installdocs
	rm -f $(CURDIR)/debian/libgecode-doc/usr/share/doc/libgecode-dev/html/jquery.js

override_dh_install-arch:
	dh_install
	find $(CURDIR)/debian/libgecode-dev/usr/include -type f -exec chmod -x {} \;
	rm -f $(CURDIR)/debian/libgecode-dev/usr/include/gecode/third-party/boost/LICENSE_1_0.txt
